% Versuch 1_3
% C. Roppel, HS Schmalkalden
% MATLAB- und Scilab-bungen zum Buch "Grundlagen der Nachrichtentechnik", Hanser-Verlag, 2023
% Getestet mit MATLAB R2020a
%%
clear
clc
close all

%% Parameter
alpha = 0.5;  % Roll-off-Faktor
os = 8;       % Samples pro Symbol (Oversampling Ratio)
dly_rc = 3;   % Verzgerung des Wurzel-Kosinus-roll-off-Filters
nSym = 1000;  % Anzahl Symbole

%% Wurzel-Kosinus-roll-off-Filter
psrc = rcosdesign(alpha, 2*dly_rc, os, 'sqrt');

%% Basisbandsignal
rng(1234);  % Initialisiere Zufallsgenerator
bits = randi([0 1], nSym, 1);  % Spaltenvektor der Lnge nSym mit Zufallszahlen 0 oder 1
symbols = 2*bits - 1;  % Binre bipolare Symbolfolge
symbols = upsample(symbols, os);  % Einfgen von os - 1 Nullen zwischen den Symbolen
x = conv(psrc, symbols);  % Faltung (convolution)
x = x(dly_rc*os + 1:end - dly_rc*os);  % Entfernen der ersten und letzten Werte

eyediagram(x, 2*os, 2);

%% Signalangepasstes Filter
ye = conv(psrc, x);
ye = ye(dly_rc*os + 1:end - dly_rc*os);

figure; 
subplot(2, 1, 1); 
plot(x(1:20*os)); 
xlabel('n'); 
ylabel('x(n)');
subplot(2, 1, 2); 
plot(ye(1:20*os)); 
xlabel('n'); 
ylabel('y_e(n)');

eyediagram(ye, 2*os, 2);

figure; 
periodogram(ye, [], [], os, 'centered');
